<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierVehicle ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierVehicle extends AbstractStructArrayBase
{
    /**
     * The IdentifierVehicle
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierVehicle[]
     */
    public $IdentifierVehicle;
    /**
     * Constructor method for ArrayOfIdentifierVehicle
     * @uses ArrayOfIdentifierVehicle::setIdentifierVehicle()
     * @param \StructType\IdentifierVehicle[] $identifierVehicle
     */
    public function __construct(array $identifierVehicle = array())
    {
        $this
            ->setIdentifierVehicle($identifierVehicle);
    }
    /**
     * Get IdentifierVehicle value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierVehicle[]|null
     */
    public function getIdentifierVehicle()
    {
        return isset($this->IdentifierVehicle) ? $this->IdentifierVehicle : null;
    }
    /**
     * This method is responsible for validating the values passed to the setIdentifierVehicle method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIdentifierVehicle method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIdentifierVehicleForArrayConstraintsFromSetIdentifierVehicle(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfIdentifierVehicleIdentifierVehicleItem) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierVehicleIdentifierVehicleItem instanceof \StructType\IdentifierVehicle) {
                $invalidValues[] = is_object($arrayOfIdentifierVehicleIdentifierVehicleItem) ? get_class($arrayOfIdentifierVehicleIdentifierVehicleItem) : sprintf('%s(%s)', gettype($arrayOfIdentifierVehicleIdentifierVehicleItem), var_export($arrayOfIdentifierVehicleIdentifierVehicleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IdentifierVehicle property can only contain items of type \StructType\IdentifierVehicle, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set IdentifierVehicle value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicle[] $identifierVehicle
     * @return \ArrayType\ArrayOfIdentifierVehicle
     */
    public function setIdentifierVehicle(array $identifierVehicle = array())
    {
        // validation for constraint: array
        if ('' !== ($identifierVehicleArrayErrorMessage = self::validateIdentifierVehicleForArrayConstraintsFromSetIdentifierVehicle($identifierVehicle))) {
            throw new \InvalidArgumentException($identifierVehicleArrayErrorMessage, __LINE__);
        }
        if (is_null($identifierVehicle) || (is_array($identifierVehicle) && empty($identifierVehicle))) {
            unset($this->IdentifierVehicle);
        } else {
            $this->IdentifierVehicle = $identifierVehicle;
        }
        return $this;
    }
    /**
     * Add item to IdentifierVehicle value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicle $item
     * @return \ArrayType\ArrayOfIdentifierVehicle
     */
    public function addToIdentifierVehicle(\StructType\IdentifierVehicle $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierVehicle) {
            throw new \InvalidArgumentException(sprintf('The IdentifierVehicle property can only contain items of type \StructType\IdentifierVehicle, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IdentifierVehicle[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierVehicle|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierVehicle|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierVehicle|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierVehicle|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierVehicle|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierVehicle
     */
    public function getAttributeName()
    {
        return 'IdentifierVehicle';
    }
}
